    using System; 
    
    public class Amount {
        public  Amount(double buy)        { this.buy = buy;            }
        public  double   Get()            { return buy;                }
        public  Discount CreateDiscount() { return new Discount(this); }
        private double   buy;
    }

    public class Discount {
        public  Discount(Amount amount) { this.amount = amount; }
        public  double Apply() { 
            return amount.Get() * 0.80; // Callback amount to apply 20% discount. 
        } 
        private Amount amount;
    }

    public class TestCallback {
        public static double TotalWithDiscount(Amount a) {
            return a.CreateDiscount().Apply(); // Create a discount then apply.
        }
        public static double TotalWithNoDiscount(Amount a) {
            return a.Get();
        }
        public static void Main() {
            Amount a = new Amount(60.00);

            // Use amount without applying a discount (no call back).
            
            Console.WriteLine("Please pay {0:C} (no  discount)", TotalWithNoDiscount(a));

            // Use amount and apply a discount (call back).
            
            Console.WriteLine("Please pay {0:C} (20% discount)", TotalWithDiscount(a));
        }
    }
