using System;

public class Value {
    public void Inc() { v++; }
    public override string ToString() { return "Value("+v+")"; }
    public object Clone() { // Shallow copy of v
        return this.MemberwiseClone(); 
    }
    private int v;
}
public class ShallowCopy {
    public ShallowCopy(Value v) { r = v; }
    public override string ToString() { return r.ToString(); }
    public object Clone() { // Shallow copy of r
        return this.MemberwiseClone(); 
    }
    private Value r;
}
public class DeepCopy {
    public DeepCopy(Value v) { r = v; }
    public override string ToString() { return r.ToString(); }
    public object Clone() { // Deep copy of r
        DeepCopy clone = (DeepCopy)this.MemberwiseClone();
        clone.r = (Value)r.Clone();
        return clone;
    }
    private Value r;
}
public class TestClone {
    public static void Main() {
        Value v1 = new Value();
        v1.Inc();
        Value v2 = (Value)v1.Clone(); 
        v2.Inc();

        Console.WriteLine("v1.ToString = {0}", v1.ToString());
        Console.WriteLine("v2.ToString = {0}", v2.ToString());

        ShallowCopy sc1 = new ShallowCopy(v2);
        ShallowCopy sc2 = (ShallowCopy)sc1.Clone(); 
        v2.Inc();

        Console.WriteLine("sc1.ToString = {0}", sc1.ToString());
        Console.WriteLine("sc2.ToString = {0}", sc2.ToString());

        DeepCopy dc1 = new DeepCopy(v2);
        DeepCopy dc2 = (DeepCopy)dc1.Clone(); 
        v2.Inc();
        
        Console.WriteLine("dc1.ToString = {0}", dc1.ToString());
        Console.WriteLine("dc2.ToString = {0}", dc2.ToString());
    }
}
