using System;

public class Counter { 
    public  void Inc() { count++; }
    private int  count;
}
public class NamedCounter {
    public NamedCounter(string aName) { name = aName; }
    public void Inc()                 { count++; }
    public int  GetCount()            { return count; }
    public override string ToString() { 
        return "Counter '"+name+"' = "+count; 
    }
    public override bool Equals(object o) {
        if (o == null) return false;
        if (GetHashCode() != o.GetHashCode()) return false; // Is same hashcode? 
        if (o == this) return true;                         // Compare with itself?
        if (!(o is NamedCounter)) return false;             // Is same type as itself?
        NamedCounter nc = (NamedCounter)o;
        return name.Equals(nc.name)  &&  count == nc.count;
    }
    public override int GetHashCode() { 
        return name.GetHashCode() ^ count;                  // Exclusive or. 
    }
    private string name;
    private int    count;
}
public class TestHashCodeEquals {
    public static void Main() {
        Object         o = new Object();
        NamedCounter nc1 = new NamedCounter("nc1");
        NamedCounter nc2 = new NamedCounter("nc2");
        NamedCounter nc3 = new NamedCounter("nc1");
        Counter       c1 = new Counter();
        Counter       c2 = new Counter();

        Console.WriteLine("HashCode   o = {0}",   o.GetHashCode());
        Console.WriteLine("HashCode nc1 = {0}", nc1.GetHashCode());
        Console.WriteLine("HashCode nc2 = {0}", nc2.GetHashCode());
        Console.WriteLine("HashCode nc3 = {0}", nc3.GetHashCode());
        Console.WriteLine("HashCode  c1 = {0}",  c1.GetHashCode());
        Console.WriteLine("HashCode  c2 = {0}",  c2.GetHashCode());

        Console.WriteLine("nc1 == null? {0}", nc1.Equals(null)?"yes":"no");
        Console.WriteLine("nc1 == nc1?  {0}", nc1.Equals(nc1) ?"yes":"no");
        Console.WriteLine("nc1 == o?    {0}", nc1.Equals(o)   ?"yes":"no");
        Console.WriteLine("nc1 == nc2?  {0}", nc1.Equals(nc2) ?"yes":"no");
        Console.WriteLine("nc1 == nc3?  {0}", nc1.Equals(nc3) ?"yes":"no");

        Console.WriteLine(" c1 == null? {0}", c1.Equals(null) ?"yes":"no");
        Console.WriteLine(" c1 == c1?   {0}", c1.Equals(c1)   ?"yes":"no");
        Console.WriteLine(" c1 == o?    {0}", c1.Equals(o)    ?"yes":"no");
        Console.WriteLine(" c1 == c2?   {0}", c1.Equals(c2)   ?"yes":"no");
    }
}
