class Counter { 
    public  virtual byte Max { 
        get { return System.Byte.MaxValue; } 
    }
    public  virtual byte Count {
        set { count = value; }
        get { return count;  }
    }
    public override string ToString() {
        return ""+Count+"[0.."+Max+"]";
    }
    private byte count;
}

class BoundedCounter : Counter {
    public BoundedCounter(byte max) { this.max = max; }

    public  override byte Max   { 
        get { return max; } 
    }
    public  override byte Count {
        set { 
            if (value > Max) base.Count = Max; 
            else base.Count = value;
        }
    }
    private byte max;
}

class TestCounter {
    public static void Main(string[]  args) {
        Counter c = new Counter();
        System.Console.WriteLine(c.ToString());
        c.Count = 4;
        System.Console.WriteLine(c.ToString());

        c = new BoundedCounter(5);
        System.Console.WriteLine(c.ToString());
        c.Count = 6;
        System.Console.WriteLine(c.ToString());
    }
}
