namespace NT { // Using Nested Types
    public class A {
        public A() { DoInternalWork(); }
        
        // Internal methods:
        static void CallBack() {}
        void DoInternalWork() {
            new S().M();
            new C().M();
            new M(A.CallBack)();
        }
        
        // Internal nested types:
        internal interface I { void M();   }
        internal class  C : I { public void M() {} }
        internal struct S : I { public void M() {} }
        internal delegate void M();
    }
}    
    
namespace IT { // Using Internal Types
    public class A {
        public A() { DoInternalWork(); }
        
        // Internal methods:
        static void CallBack() {}
        void DoInternalWork() {
            new S().M();
            new C().M();
            new M(A.CallBack)();
        }
    }
    // Internal types:
    interface I { void M();   }
    class  C : I { public void M() {} }
    struct S : I { public void M() {} }
    delegate void M();
}    
