using System;

namespace SubclassConstructors {
    abstract class Counter {
        public Counter(int c) { count = c; }
        public    abstract  void    Tick();

        public    int     GetCount()  { return count; }
        protected void    Inc()       { ++count; }
        protected void    Dec()       { --count; }

        private   int     count;
    }

    class DownCounter : Counter {
        public DownCounter(int count) : base(count) { }
        public override void Tick() { Dec(); }
    }

    class UpCounter : Counter {
        public UpCounter(int count) : base(count) { }
        public override void Tick() { Inc(); }
    }

    public class TestAbstractCounter {
        public static void Main() {
            Counter[] counters = { new UpCounter(0), new DownCounter(9) };

            for (int c = 0; c < counters.Length ; c++) {
                Console.WriteLine("Counter starting at: "+counters[c].GetCount());
                for (int n = 0; n < 5; n++) {
                    Console.Write(counters[c].GetCount());
                    counters[c].Tick();
                }
                Console.WriteLine();
            }
        }
    }
}
