delegate void UpdateEventHandler();

class Subject {
    private int  data;
    public  int  GetData()          { return data; }
    public  void SetData(int value) { data = value; Changed(); }
    public event UpdateEventHandler Changed;
}
class Observer {
    public Observer(Subject s)  { subject = s;  }
    public Subject GetSubject() { return subject; }
    private Subject subject;
}
class HexObserver : Observer {
    public HexObserver(Subject s) : base(s) { 
        s.Changed += delegate { System.Console.Write("0x{0:X} ", GetSubject().GetData()); }; 
    }
}
class DecObserver : Observer {
    public DecObserver(Subject s) : base(s) {
        s.Changed += delegate { System.Console.Write("{0} ", GetSubject().GetData()); }; 
    }
}
class TestEvent {
    public static void Main() {
        Subject s = new Subject();
        HexObserver  ho = new HexObserver(s);
        DecObserver  co = new DecObserver(s);
        
        for (int c;;) {
            System.Console.Write("\nEnter a character (followed by a return, ctrl-C to exit): ");
            c = System.Console.Read();
            s.SetData( c );
            System.Console.Read(); // Two reads to get rid of the \r\n on PC.
            System.Console.Read();
        }
    }
}
