using System;

namespace NewModifier {
    public interface ICountable {
        bool Tick();
    }
    public class Counter : ICountable {
        public                 Counter () { count = 0; }
        public          int    GetCount() { return count; }
        public override string ToString() { return count.ToString(); }
        protected       void   SetCount(int newCount) { count = newCount;}
        public virtual  bool   Tick()     { return ++count == Int32.MaxValue; }

        private         int  count;
    }
    public class NewCounter : Counter {
        public NewCounter(int max) : base() { this.max = max; }
        public new virtual int GetCount()   { return  base.GetCount(); }
        public override bool   Tick() { 
            SetCount(base.GetCount()+1); 
            if (base.GetCount() == GetMax()) { 
                SetCount(0);
                return true;
            }
            return false;
        }
        public  int GetMax() { return max; }
        
        private int max;
    }
    public class TestNewModifier {
        public static void Main() {
            ICountable c  = new Counter();
            NewCounter c2 = new NewCounter(3);

            for (int n = 0; n < 9; n++) {
                System.Console.Write( c.ToString() );  c.Tick();
            }
            System.Console.WriteLine();

            for (int n = 0; n < 9; n++) {
                System.Console.Write( c2.ToString() ); c2.Tick();
            }
            System.Console.WriteLine();
        }
    }
}
