using System.Collections;

public class IntCollection : IEnumerable {
    public IntCollection(int[] numbers) { 
        this.numbers = numbers; 
    }
    public virtual IEnumerator GetEnumerator() { 
        return new IntEnumerator(numbers); 
    }
    // ...
    private int[]  numbers;
}

class IntEnumerator : IEnumerator {
    public  IntEnumerator(int[] list) { 
        this.list = list; Reset(); 
    }
    public object Current { 
        get { return list[index]; } 
    }
    public bool MoveNext() { 
        return ++index < list.Length; 
    }
    public void Reset() { 
        index = -1; 
    } 
    private int[]  list;
    private int    index;
}

class TestIntCollection {
    public static void Main() {
        IntCollection ic = new IntCollection(new int[] {1, 2, 3, 4, 5, 6, 7, 8, 9});
        IEnumerator   e  = ic.GetEnumerator();

        foreach (int n in ic) 
            System.Console.WriteLine("{0}", n);
    }
}
