using System;
using System.Collections;

namespace T {
    public class TestBasicCollections {
        public static void Print(string name, ICollection c) {
            Console.Write("[{0,2} items] {1,2}: ", c.Count, name);
            foreach (bool b in c) 
                Console.Write("{0} ", b ? "1" : "0");
            Console.WriteLine();
        }
        
        public static void Main() {
            byte[]    bytes = { 0x55, 0x0F };  // two bytes (16 bits)
            bool[]    bools = { true, false, true };
            Array     ba    = new bool[3];
            BitArray  b1    = new BitArray(8, true);
            BitArray  b2    = new BitArray(bytes);
            BitArray  b3    = new BitArray(bools);
            ArrayList a     = new ArrayList(bools); 
            Stack     s     = new Stack(b3);
            Queue     q     = new Queue(b3);

            b3.CopyTo(ba, 0);
            s.Push(true);
            q.Dequeue();            

            Print("b1", b1);
            Print("b2", b2);
            Print("b3", b3);
            Print("ba", ba);
            Print("a", a);
            Print("s", s);
            Print("q", q);
        }
    }
}
