using System;
using System.Collections;

namespace T {
    // To sort in reverse alphabetical order
    public class ReverseOrderComparer : IComparer {
        public int Compare(object x, object y) {
            string sx = x.ToString();
            string sy = y.ToString();
            
            return -sx.CompareTo(sy);
        }
    }
    // To get a different hash code (first + last + length)
    public class HashCodeGen : IHashCodeProvider {
        public int GetHashCode(object o) {
            string s = o.ToString();
            return s[0] + s[s.Length-1] + s.Length;
        }
    }

    public class TestDictionaries {
        public static void Print(string name, IDictionary d) {
            Console.Write("{0,2}: ", name);
            foreach (DictionaryEntry e in d) 
                Console.Write("{0} ", e.Key);
            Console.WriteLine();
        }
        public static void Main() {
            Hashtable h1 = new Hashtable();
            h1.Add("Michel", "Michel de Champlain");
            h1.Add("Brian",  "Brian G. Patrick");
            h1.Add("Helene", "Helene Lessard");

            SortedList s1 = new SortedList(h1);
            SortedList s2 = new SortedList(h1, new ReverseOrderComparer());
            Hashtable  h2 = new Hashtable(h1, new HashCodeGen(), new ReverseOrderComparer() );
            
            Print("h1", h1);
            Print("s1", s1);
            Print("s2", s2);
            Print("h2", h2);
            h2.Add("Be",  "Be Sharp");
            Print("h2", h2);
            h1.Add("Be",  "Be Sharp");
            Print("h1", h1);
        }
    }
}
