using System;
using System.Collections;

namespace T {
    public class SpecialList : ArrayList {
        public SpecialList(ICollection c) : base(c) { }
        public override IEnumerator GetEnumerator() { 
            return new SpecialEnumerator(this);
        }
    }

    internal class SpecialEnumerator : IEnumerator {
        public SpecialEnumerator(ArrayList list) {
            this.list = list;
            Reset();
        }
        public bool   MoveNext() { return --index >= 0; }
        public object Current    { get { return list[index]; } }
        public void   Reset()    { index = list.Count; }
        
        private ArrayList list;
        private int       index;
    }

    public class TestNewIterator {
        public static void Print(string name, IEnumerable list) {
            Console.Write("{0,2}: ", name);
            foreach (string s in list) 
                Console.Write("{0} ", s);
            Console.WriteLine();
        }
        public static void Main() {
            ArrayList al = new ArrayList();
            al.Add("Michel");
            al.Add("Brian");
            al.Add("Glen");
            al.Add("Patrick");

            SpecialList sl = new SpecialList(al);

            Print("al", al);
            Print("sl", sl);
        }
    }
}
