using System.IO;

namespace BinaryStream {
    class TestBinaryStream {
        static void Main() {
            uint magicNumber = 0xDECAF;
            
            ushort[] data = { 0x0123, 0x4567, 0x89AB, 0xCDEF };
            
            FileStream   fs = new FileStream("file.bin", FileMode.Create);
            BinaryWriter bw = new BinaryWriter(fs);

            bw.Write(magicNumber);
            foreach (ushort u in data)
                bw.Write(u);

            bw.Close();
            
            fs = new FileStream("file.bin", FileMode.Open);
            BinaryReader br = new BinaryReader(fs);

            System.Console.WriteLine("{0:X8}", br.ReadUInt32() );            
            for (int n = 0; n < data.Length; n++)
                System.Console.WriteLine("{0:X4}", br.ReadUInt16() );            

            br.Close();
        }
    }
}
