using System.Threading;

namespace BasicDotNet {
    public class MainThread {
        private static void One() { System.Console.WriteLine("1"); Thread.Sleep(1000); }
        private static void Two() { System.Console.WriteLine("2"); Thread.Sleep(2000); }
        
        public static void Main() {
            Thread  t1 = new Thread(One);
            Thread  t2 = new Thread(Two);
            Thread  me = Thread.CurrentThread;
            System.Console.WriteLine("Main [{0}].", me.IsAlive ? "Alive" : "Unstarted");
            System.Console.WriteLine("One  [{0}].", t1.IsAlive ? "Alive" : "Unstarted");
            System.Console.WriteLine("Two  [{0}].", t2.IsAlive ? "Alive" : "Unstarted");
            t1.Start();
            t2.Start();
            System.Console.WriteLine("One  [{0}].", t1.IsAlive ? "Alive" : "Unstarted");
            System.Console.WriteLine("Two  [{0}].", t2.IsAlive ? "Alive" : "Unstarted");

            t1.Join();
            System.Console.WriteLine("One joined.");
            System.Console.WriteLine("One  [{0}].", t1.IsAlive ? "Alive" : "Ended");

            t2.Join();
            System.Console.WriteLine("Two joined.");
            System.Console.WriteLine("Two  [{0}].", t2.IsAlive ? "Alive" : "Ended");
            System.Console.WriteLine("Main ending...");
        }
    }
}
