using System.Threading;

namespace BasicDotNet {
    public class MyThread {
        public MyThread(int number) {
            t = new Thread(Run);
            this.number = number;
            t.Start();
        }
        private void Run() {
            while (true) {
                Thread.Sleep(number * 1000);
                System.Console.Write("{0}", number);
            }
        }
        public void Suspend() { 
            System.Console.WriteLine("\nThread {0} suspended", number);
            t.Suspend(); 
        }
        public void Resume() { 
            System.Console.WriteLine("\nThread {0} resumed", number);
            t.Resume(); 
        }
        public void Stop() { 
            System.Console.WriteLine("\nThread {0} stopped", number);
            t.Abort(); 
        }
        private Thread  t;
        private int     number;
    }
    
    public class MainThread {
        public static void Main() {
            System.Console.WriteLine("Main Started.");
            MyThread t1 = new MyThread(1);
            MyThread t2 = new MyThread(2);
            
            Thread.Sleep(10 * 1000);
            t1.Suspend();
            Thread.Sleep(10 * 1000);
            t1.Resume();
            Thread.Sleep(10 * 1000);
            t1.Stop();
            Thread.Sleep(10 * 1000);
            t2.Stop();
            
            System.Console.WriteLine("Main: done.");
        }
    }
}
