using System;
using System.Reflection;

namespace TestReflection {
    public class ClassAndMembers {
        public static void Print(Type t) {
            Console.WriteLine("\n{0}", t);
            
            MemberInfo[] members = t.GetMembers();
            
            foreach(MemberInfo m in members)
                Console.WriteLine("\t{0,-11}  {1,-11}", m.MemberType, m.Name);
        }
        public static void Main() {
            Print(typeof(object));
            Print(typeof(bool));
            Print(typeof(ClassAndMembers));
        }
    }
}
