using System;
using System.Reflection;

interface      MyInterface { }
abstract class MyAbstractClass { }
public class   MyBaseClass { }
sealed class   MyDerivedClass : MyBaseClass { }
struct         MyStruct { }

class TypesInfo {
    private const string FORMAT = "{0,-16} {1,-8} {2,-5} {3,-9} {4,-9} {5,-6} {6,-6} {7,-9}";
    public static void GetTypeInfo(string typeName) {
        Type t = Type.GetType(typeName);

        Console.WriteLine(
            String.Format(FORMAT, t.FullName,    t.IsAbstract, t.IsClass,  t.IsInterface, 
                                  t.IsPrimitive, t.IsPublic,   t.IsSealed, t.IsValueType)
            );
    }
    public static void Main() {
        Console.WriteLine(String.Format(FORMAT+"\n", "Type", "Abstract", "Class", "Interface", 
                                                 "Primitive", "Public", "Sealed", "ValueType")
        );            
        GetTypeInfo("System.Int32");
        GetTypeInfo("System.Type");
        GetTypeInfo("MyInterface");
        GetTypeInfo("MyAbstractClass");
        GetTypeInfo("MyBaseClass");
        GetTypeInfo("MyDerivedClass");
        GetTypeInfo("MyStruct");
    }
}
